// Show list of stories (later stories and defects) that were blocked between an arbitrary time range.

Ext.define('CustomApp', {
    extend: 'Rally.app.App',
    componentCls: 'app',
    launch: function () {
        //Write app code here
        console.log("Hello World!");

        this.app = this;  // Is this correct?  Is this necessary?  Is this pun intended?

        // Explicitly create a Container
        this.topContainer = Ext.create('Ext.panel.Panel', {
            layout: {
                type: 'hbox',
                align: 'stretch'
            },
            name: 'timeFramePanel',
            itemId: 'timeFramePanel',
            width: '100%',
            title: 'Time Frame',
            titleAlign: 'center',
            renderTo: Ext.getBody(),
            border: true,
            style: {
                borderColor: '#000000',
                borderStyle: 'solid',
                borderWidth: '1px'
            },
            defaults: {
                labelWidth: 80,
                // implicitly create Container by specifying xtype
                // xtype: 'datefield',
                align: 'stretch',
                flex: 1,
                style: {
                    padding: '12px'
                }
            },
            items: [{
                xtype: 'panel',
                flex: 1,
                name: 'timeboxesPanel',
                itemId: 'timeBoxesPanel',
                title: 'Timeboxes',
                titleAlign: 'center',
                border: true,
                borderWidth: 4,

                items: [{
                    xtype: 'rallyreleasecombobox',
                    name: 'release',
                    itemId: 'release',
                    fieldLabel: 'Release: ',
                    padding: 6,
                    border: true,
                    borderWidth: 4,
                    listeners: {
                        select: _releaseChanged,
                        scope: this.app
                    }
                }, {
                    xtype: 'rallyiterationcombobox',
                    name: 'iteration',
                    itemId: 'iteration',
                    fieldLabel: 'Iteration: ',
                    padding: 6,
                    border: true,
                    borderWidth: 4,
                    listeners: {
                        select: _iterationChanged,
                        scope: this.app
                    }
                }]
            },
            {
                xtype: 'panel',
                flex: 1,
                name: 'dateRangePanel',
                itemId: 'dateRangePanel',
                title: 'Date Range',
                titleAlign: 'center',
                items: [{
                    xtype: 'datefield',
                    name: 'startDate',
                    itemId: 'startDate',
                    fieldLabel: 'Start date',
                    padding: 6,
                    border: true,
                    borderWidth: 4,
                    listeners: {
                        change: _startDateChanged,
                        scope: this.app
                    }
                }, {
                    xtype: 'datefield',
                    name: 'endDate',
                    itemId: 'endDate',
                    fieldLabel: 'End date',
                    padding: 6,
                    border: true,
                    borderWidth: 4,
                    listeners: {
                        change: _endDateChanged,
                        scope: this.app
                    }
                }]
            }
            ]
        });

        this.add(this.topContainer);
        console.log(this);

        //API Docs: https://help.rallydev.com/apps/2.1/doc/
    },    
});

function _releaseChanged (rallyreleasecombobox, release, eOpts) {
    // set the start and end dates to the start and end dates of the timebox.
    console.log("Release changed: ", release);
}

function _iterationChanged (rallyiterationcombobox, iteration, eOpts) {
    // set the start and end dates to the start and end dates of the timebox.
    console.log("Iteration changed: ", iteration);
}

function _startDateChanged (datefield, newDate, eOpts) {
    // reset timeboxes to none
    console.log("Start Date changed: ", newDate);
}

function _endDateChanged (datefield, newDate, eOpts) {
    // validate that end date is > start date
    var startDate = null;
    if (startDate === undefined || startDate === null) {
        console.log("Start Date Unset");
    } else if (newDate.getValue() > startDate) {
        console.log("End Date <= Start Date");
    } else {
        console.log("End Date changed to: ", newDate.getValue());
    }
    // reset timeboxes to none
    // console.log("End Date changed: ", newDate);
}
